      subroutine limiter(N,Ng,var,vertxC,vertxL,varL,varR)
      implicit none
      real*8 var(*),varL(*),varR(*),vertxC(*),vertxL(*)
      integer N,Ng,i
      do i=Ng+1,N-Ng+1
        call recosLR(var(i-2),var(i-1),var(i),
     &         var(i+1),vertxC(i-2),vertxC(i-1),vertxC(i),
     &         vertxC(i+1),vertxL(i),varR(i-1),varL(i))
      enddo
      return
      end


      subroutine  recosLR(q1,q2,q3,q4,xm1,xm2,xm3,xm4,x3,qL,qR)
      implicit none
      real*8 q1,q2,q3,q4,qL,qR,minmod
      real*8 xm1,xm2,xm3,xm4,x3,s1,s2,s3,sigma1,sigma2
      s1 = (q2-q1)/(xm2-xm1)
      s2 = (q3-q2)/(xm3-xm2)
      s3 = (q4-q3)/(xm4-xm3)
      sigma1 = minmod(s1,s2)
      sigma2 = minmod(s2,s3)
      qL = q2+sigma1*(x3-xm2)
      qR = q3+sigma2*(x3-xm3)
      return
      end

      real*8 function minmod(a, b)
      implicit none
      real*8  a,b
      if (a*b.le.0.0d0 )  then
          minmod = 0.0d0
      elseif (abs(a).le.abs(b)) then
          minmod=a
      else
          minmod=b
      endif
      return
      end

